/*
  Blink

Hacking into an ATtiny85:
https://learn.sparkfun.com/tutorials/re-programming-the-lilytiny--lilytwinkle
http://highlowtech.org/?p=1695

Written for Dubai Mini Maker Faire hackathon (ATtiny85)
15-Mar Update - Re-mapped pins for week 9 Embedded Programming Assignment (ATtiny44)
18-Mar Update - Re-mapped pins for week 9 Embedded Programming Assignment (ATmega328P)
Carl P-Conquilla
2018
*/



int emergency = 0;
// the setup function runs once when you press reset or power the board
void setup() {
  pinMode(5, OUTPUT);   //LED pins
  pinMode(1, OUTPUT);   //LED pins
  pinMode(3, INPUT);    //Emergency mode button
  pinMode(4, OUTPUT);   //LED pins
  for(int f=5; f<255; f++) {    //Fade to high on startup like a MacBook
    analogWrite(5, f);
    delay(1);
  }
  delay(15000);
  for(int f=0; f<255; f++) {    //Decay to low after some time to show device is ready
    analogWrite(5, 255-f);
    delay(6);
  }
}

// the loop function runs over and over again forever
void loop() {
  if (digitalRead(3) == HIGH) {   //Check to see if the emergency circuit is activated
    emergency = 8;                //Set the timer for emergency to 8 cycles
    digitalWrite(5, HIGH);
    delay(100);
    digitalWrite(5, LOW);
  }
//  if (digitalRead(2) == HIGH) {
//    digitalWrite(0,100);
//  } else {
//    digitalWrite(0, 0);
//  }
  if (emergency >= 1) {           //If the emergency timer is still greater than 0 do the flash
    digitalWrite(5, 0);
    for (int j=0; j < 2; j++) {   //Flash triples, twice on each LED set
      for (int i=0; i< 3; i++) {
        digitalWrite(5, HIGH);   // LED on
        delay(30);                       // wait
        digitalWrite(5, LOW);    // LED off
        delay(30);                       // wait
      }
      delay(100);
      for (int i=0; i< 3; i++) {
        digitalWrite(5, HIGH);   // LED on
        delay(30);                       // wait
        digitalWrite(5, LOW);    // LED off
        delay(30);                       // wait
      }
    }   
    emergency = emergency - 1;      //Decrement the emergency counter
  }
}
